{*************************************************************
   Kurso "Informatika" 2008/09 m.m. pavasario sem.
   2-as praktinis darbas. Variantas Nr. 214
   Darb atliko: Oleg Ralovec
 *************************************************************}
Unit CntInput;

Interface

Const Data_file = 'testui.cnt';
      SEP1 = '=';
      SEP2 = ':';
      
Type Info = Record
     Title :String;
      Base :String;
  OtherInf :String;
            End;

Type Table = ^elem;
     elem = Record
         Number :Integer;
          Topic :String;
           Page :String;
           Next :Table
            End;

Function OpenedFile(Var t :Text) :Boolean;  // Patikrina ar egzistuoja failas prie kurio nurodytas kelias, ji atidaro
Function ClosedFile(Var t :Text) :Boolean ; //Uzdaro faila jei jis egzistuoja
Procedure InfoReader (Var inform :String; Var f2 :Text); //Nuskaito informacija cnt failo pradzioje(informacija)
Procedure StrSegmentator(Var line, s1, s2 :String ); //Dalyja eilute i dvi dalis priklausomai nuo skirtuko
Procedure TableReader(Var f2 :Text;  Var p :Table ); //Nuskaito cnt failo duomenis i sarasa
Procedure InfoMain (Var cont :Info; Var f2 :Text); //Sugrupuoja veiksmus informacijai ape *.cnt nuskaityti.
Procedure FreeSpace (Var p : Table );  //Atlaisvina saraso uzimama vieta

Implementation

Var c :Char;
//------------------------------------------------------------------------------
Function OpenedFile(Var t :Text) :Boolean;
Begin
  Assign (t, Data_file);
  {$i-}
  Reset (t);
  {$i+}
  If IOresult <> 0 then  OpenedFile := False
                   else  OpenedFile := True;
End;


Function ClosedFile(Var t :Text) :Boolean ;
  Begin
  If OpenedFile(t) = True  then
    Begin
      {$I-} Close(t); {$I+}
      If IOResult <> 0 then ClosedFile := False
                       else ClosedFile := True;
    End;
  End;
  
//------------------------------------------------------------------------------

Procedure InfoReader (Var inform :String; Var f2 :Text);
Var str :String;
Begin
    ReadLn(f2, str);
    inform := inform + #10 + str;
    Read(f2, c);
End;

Procedure StrSegmentator(Var line, s1, s2 :String );
Begin
  If pos(SEP1, line) = 0 then  s1 := line
    else
      Begin
        s1 := copy(line, 1, pos(SEP1, line) - 1);
        s2 := copy(line, pos(SEP1, line) + 1, length(line));
      End;
End;


Procedure TableReader(Var f2 :Text;  Var p :Table );
Var p1 :Table;
   str :String;  //laikinas kint. eilutes nuskaitymui
Begin
 new(p);
 val(c, p^.number);
 ReadLn(f2, str);
 StrSegmentator(str, p^.topic, p^.page);
 p1 := p;
 While not(eof(f2))  do
    Begin
      Read(f2,c);
      new(p^.next);
      p := p^.next;
      val(c, p^.number);
      ReadLn(f2, str) ;
      StrSegmentator(str, p^.topic, p^.page);
    End;
  p^.next := nil;
  p := p1;
End;

Procedure InfoMain (Var cont :Info; Var f2 :Text);
Begin
  Read(f2, c);
  If c = SEP2  then
                 Begin
                   InfoReader(cont.base, f2);
                   InfoReader(cont.title, f2) ;
                 End;
  While c = SEP2  do  //jei yra kita papildoma informacija pridedam ja prie cont.OtherInf
   InfoReader(cont.OtherInf, f2);
End;

//------------------------------------------------------------------------------

Procedure FreeSpace ( Var p : Table );
Var p1 : table;
Begin
  While p <> nil do
    Begin
      p1 := p;
      p := p^.next;
      dispose(p1);
    End;
End;

END.
